#!/usr/bin/perl

use LWP;
use LWP::Simple;
use URI::URL;
use LWP::UserAgent;

$root = "/export/home/mln/public_html/projects/persistence/";

foreach $dl (@ARGV) {

	print "doing $dl\n";

	# undefine all the variables so each DL starts clean
	undef %objects;	
	undef %sizes;	

	chdir ("$root/$dl");

	# read in the list of urls
	open (O,"objects");

	while (<O>) {
		($metadata, $data) = split;
		$objects{"$metadata"} = $data;
	}
	close(O);
	
	# determine the name of the output file
	if (-f "baseline") {

		# find the baseline size for the urls
		open (B,"baseline");
		while (<B>) {
			($data, $size) = split;
			$sizes{"$data"} = $size;
		}
		close(B);

		# name the output file YYYY-MM-DD
	        ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = 
                	gmtime;
		
        	if ($year < 100) {
                	$year = "19$year";
        	} elsif ( ($year >=100) && ($year <2000) ) {
                	$year += 1900;
        	}
        	$mon++;         # 0 indexed
        	if ($mon < 10) { $mon = "0$mon"; }
        	if ($mday < 10) { $mday = "0$mday"; }

        	$name = "$year-$mon-$mday";
	} else {
		# this is the first time this DL has been checked
		$name = "baseline";
	}

	# append to the file if it already exists
	open (D,">>$name");	
	$ts = `date`;
	print D "beginning at $ts";
	foreach $metadata (keys(%objects)) {
		sleep (2);
		print "get'ing $objects{$metadata}\n";
		$file = get($objects{"$metadata"});

		if ($file =~ /<TITLE>Document Unavailable/) {
			# this is for Dienst, which can send an html
			# response even though the file is inaccessible

			$file_length = 0;
		} elsif ($file =~ /<\/H2>Sorry, that format for document/)  {
			print "problems with $objects{$metadata} ; trying $metadata\n";
			$newfile = get($metadata);
			if ($newfile =~ /<TITLE>Document Unavailable/) {
				# we're checking on the metadata file
				# since the format was not available
				$file_length = 0;
			} else {
				$file_length = length ($file);
			}
		} else {
			$file_length = length ($file);
		}

		if ($name eq "baseline") {
			print D "$objects{$metadata} $file_length\n";
			print "$objects{$metadata} $file_length\n";
			next;
		}
	
		if ($file_length != $sizes{$objects{$metadata}}) {
			print D "$objects{$metadata} is $file_length -- expected $sizes{$objects{$metadata}}\n"; 
			print "$objects{$metadata} is $file_length -- expected $sizes{$objects{$metadata}}\n"; 
                	$file = new HTTP::Request GET => '$objects{$metadata}';
                	$ua = new LWP::UserAgent;
                	$res = $ua->request($file);
			print D "http code and status:" . $res->code . $res->status_line . "\n";
			print "http code and status:" . $res->code . $res->status_line . "\n";
		} else {
			# only print to stdout; don't log expected results
			print "$objects{$metadata} is still $file_length -- no change\n"; 
		}
	}
	$ts = `date`;
	print D "ending at $ts";
	close (D);
}

